#include <stdio.h>

/* We define a simple version of this ourselves because with some broken
 * Solaris gcc installations,  this standard library header blows up...
 */

#define assert(x) \
  do { if (!x) { fprintf (stderr, "Failed assertion at %s, line %d: %s\n", \
                          __FILE__, __LINE__, # x); } } while (0)
