#include <httpd.h>
#include <http_config.h>
#include <tcl.h>

/* Glue which mediates between Apache and aolserver data structures */

extern module aolserver_module;
extern server_rec *Tcl_server;	/* sole virtual server we run in, for now */
extern request_rec *Tcl_request_rec;
extern pool *Tcl_pool;
extern char *nsServer;

#define TCL_POOL() (Tcl_request_rec? Tcl_request_rec->pool : Tcl_pool)

int Ns_TclInitInterps (char *server, int (*)(Tcl_Interp *, void*), void *);

