#include <httpd.h>
#include <http_log.h>

typedef int Ns_LogSeverity;

/* No way to tell if it actually makes sense to log errno on these or not,
 * so we err on the side of displaying possibly irrelevant info...
 */

#define Debug   APLOG_DEBUG
#define Notice  APLOG_NOTICE
#define Warning APLOG_WARNING
#define Error   APLOG_ERR
#define Fatal   APLOG_EMERG
#define Bug     APLOG_EMERG
#define Dev     APLOG_EMERG

typedef char *Ns_ModLogHandle;

void Ns_ModLog (Ns_LogSeverity, Ns_ModLogHandle, const char *, ...);
void Ns_Log (Ns_LogSeverity, const char *, ...);
void NsModLogRegSubRealm (char *, Ns_ModLogHandle *);
void LogError (char *);
